# upstate
 
Upstate is a state management library for Flutter that is meant to be much simpler to use
than existing solutions and yet provide advanced functionality and extensibility
as your app scales. Like Flutter itself, it provides a continous workflow
from the prototyping stage all the way to production without having to switch tools. It is also
great for new developers.

## Installation  
To use Upstate, add it to your dependencies in your pubspec.yaml file: 
```
dependencies:
  upstate:
``` 

## Usage 
To get started quickly check out the [examples](https://github.com/jonaird/upstate/tree/master/example/lib). 
 
For more information check out my Medium articles: 
1. [Introduction](https://levelup.gitconnected.com/introducing-upstate-simplified-state-management-for-flutter-c987cac25b04) 
2. [Behind the Scenes](https://medium.com/@jonathan.aird/upstate-behind-the-scenes-2fe08c5d50c7)  
3. [Type Safety](https://medium.com/@jonathan.aird/adding-type-safety-to-upstate-654f899ebdbc) 
4. [Custom State Objects](https://medium.com/@jonathan.aird/using-upstate-with-any-kind-of-state-object-599b01ec4751) 
 
And the [API documentation](https://jonaird.github.io/upstate_api_docs/upstate/upstate-library.html)
 
Upstate exposes many low level API's that can be mixed and matched to do lots of different things that
I don't have the time to go into in detail.
If you're wondering if you can do something specific, you probably can. Just submit an issue about it
and I will get back to you asap.